	device zxspectrum48
        ORG #6000
begin

;ula on
	ld bc,$BF3B;48955
	ld a,64
	out (c),a
	ld b,$FF;ld bc,$FF3B;65339
	ld a,1
	out (c),a

	di
; draw attr
;	ld hl,$5800
;da:
;	ld a,l
;	and 15
;	add a,a
;	add a,a
;	add a,a
;	and 127
;	ld (hl),a
;	inc l
;	bit 4,l
;	jr z,da
;define colors
	ld hl,pal
	ld b,(pale-pal)/2
dc:
	push bc
	ld a,(hl):inc hl
	ld bc,$BF3B;48955
	out (c),a
	ld b,$FF;ld bc,65339
	ld a,(hl):inc hl
	out (c),a
	pop bc
	djnz dc
;----------------plasma---------------------------------
sta equ $BE00 ; sinus table
;generate
	exx
	ld hl,sta
	exx
	ld hl,0
	ld de,hl
v1:
;		ld	hl, 0
		ld	a, h
		cp	32/4

v2:
;		ld	de, 0
		ex	de, hl
		ld	bc, 4
		jr	c, br1
		and	a
		sbc	hl, bc
		jr	br2

br1:
		add	hl, bc

br2:
		ex	de, hl
		add	hl, de
;		ld	(v2+1), de
;		ld	(v1+1), hl
		ld	a, h
	exx
;	add a,l
	ld (hl),a
;? LUT colors
	inc h
	ld a,l
;	bit 3,a
;	jr z,nocha
;	cpl
;nocha:
	and 15
	add a,a
	add a,a
	add a,a
	and 127
	ld (hl),a
	dec h
;end calc LUT
	inc l
	exx
	jp nz,v1


;plot on screen
;	ld hl,sta
;pl:
;	ld c,l
;	ld b,(hl)
;	push hl
;	CALL  8933;plot C=X,B=Y,5C7D=COORDS
;	pop hl
;	inc l
;	jr nz,pl
;
;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir
;	jr $

;prepare stack output
	ld hl,ou1
	ld de,$5800
fo1:
	ld (hl),$e1:inc hl
	ld (hl),$22:inc hl
	ld (hl),e:inc hl
	ld (hl),d:inc hl
	inc de
	inc de
	ld a,d
	cp $5B
	jr nz,fo1
	ld (hl),$31:inc hl
	ld (outs+2),hl
	inc hl,hl
	ld (hl),$C9:inc hl
;	jr $
;frame1
doplasma:
	ei:halt
	call outs
	exx
v_1: ld bc,0
	ld h,sta/256
	dec c,c
	dec b
	ld (v_1+1),bc
	exx
v_2: ld de,0
	ld bc,$8000
	ld h,sta/256
	dec d,d
	inc e;,e
	ld (v_2+1),de
ylp:
	exx
	ld l,c
	ld a,(hl)
	ld l,b
	add a,(hl)
	ld ixl,a
;	inc c
;	dec b
	ld a,b
va1:	add a,3
	ld b,a
	ld a,c
va2:	add a,-2
	ld c,a
 	exx
	push de

;row
; dup 32
rlp:
	ld l,e
	ld a,(hl)
	ld l,d
	add a,(hl)
	add a,ixl
	inc h
	ld l,a
	ld a,(hl)
	dec h
	inc e,e
	dec d
	ld (bc),a
	inc bc
	
	ld a,c
	and 31
	jp nz,rlp
;edup
	pop de

	ld a,b
	cp $83
	jp nz,ylp
; move
	inc ixh
	jr nz,nopar
	ld a,r
gp:
	inc a
	and 7
	jr z,gp
	ld (va1+1),a
	sub 4
	ld (va2+1),a
nopar:
	jp doplasma
;wula: ;write to ports

;	to be continued
outs: ld (0),sp
	ld sp,$8000
ou1:
;--------------------------------------------------------

pal:;0xGGGRRRBB
	db 8,32*0
	db 9,32*1
	db 10,32*2
	db 11,32*3
	db 12,32*4+0
	db 13,32*5+1
	db 14,32*6+2
	db 15,32*7+3
;24-31
	db 24,32*7+3
	db 25,32*6+2
	db 26,32*5+1
	db 27,32*4+0
	db 28,32*3
	db 29,32*2
	db 30,32*1
	db 31,32*0
pale:
end
	display /d,end-begin
	savesna "!void.sna",begin
	savebin "pula.code",begin,end-begin
